# Nulla

An agnostic social network following the KISS and UNIX philosophy, the main principles of which are minimalism and rationalism. It implements the ActivityPub protocol and promises maximum compatibility with all existing implementations.

## TODO

### API

#### accounts

- [ ] POST [/api/v1/accounts](https://docs.joinmastodon.org/methods/accounts/#create)
- [ ] GET [/api/v1/accounts/verify_credentials](https://docs.joinmastodon.org/methods/accounts/#verify_credentials)
- [ ] PATCH [/api/v1/accounts/update_credentials](https://docs.joinmastodon.org/methods/accounts/#update_credentials)
- [ ] GET [/api/v1/accounts/:id](https://docs.joinmastodon.org/methods/accounts/#get)
- [ ] GET [/api/v1/accounts](https://docs.joinmastodon.org/methods/accounts/#index)
- [ ] GET [/api/v1/accounts/:id/notes](https://docs.joinmastodon.org/methods/accounts/#statuses)
- [ ] GET [/api/v1/accounts/:id/followers](https://docs.joinmastodon.org/methods/accounts/#followers)
- [ ] GET [/api/v1/accounts/:id/following](https://docs.joinmastodon.org/methods/accounts/#following)
- [ ] GET [/api/v1/accounts/:id/featured_tags](https://docs.joinmastodon.org/methods/accounts/#featured_tags)
- [ ] GET [/api/v1/accounts/:id/lists](https://docs.joinmastodon.org/methods/accounts/#lists)
- [ ] POST [/api/v1/accounts/:id/follow](https://docs.joinmastodon.org/methods/accounts/#follow)
- [ ] POST [/api/v1/accounts/:id/unfollow](https://docs.joinmastodon.org/methods/accounts/#unfollow)
- [ ] POST [/api/v1/accounts/:id/remove_from_followers](https://docs.joinmastodon.org/methods/accounts/#remove_from_followers)
- [ ] POST [/api/v1/accounts/:id/block](https://docs.joinmastodon.org/methods/accounts/#block)
- [ ] POST [/api/v1/accounts/:id/unblock](https://docs.joinmastodon.org/methods/accounts/#unblock)
- [ ] POST [/api/v1/accounts/:id/mute](https://docs.joinmastodon.org/methods/accounts/#mute)
- [ ] POST [/api/v1/accounts/:id/unmute](https://docs.joinmastodon.org/methods/accounts/#unmute)
- [ ] GET [/api/v1/accounts/:id/endorsements](https://docs.joinmastodon.org/methods/accounts/#endorsements)
- [ ] POST [/api/v1/accounts/:id/endorse](https://docs.joinmastodon.org/methods/accounts/#endorsements)
- [ ] POST [/api/v1/accounts/:id/unendorse](https://docs.joinmastodon.org/methods/accounts/#unendorse)
- [ ] POST [/api/v1/accounts/:id/note](https://docs.joinmastodon.org/methods/accounts/#note)
- [ ] GET [/api/v1/accounts/relationships](https://docs.joinmastodon.org/methods/accounts/#relationships)
- [ ] GET [/api/v1/accounts/familiar_followers](https://docs.joinmastodon.org/methods/accounts/#familiar_followers)
- [ ] GET [/api/v1/accounts/search](https://docs.joinmastodon.org/methods/accounts/#search)
- [ ] GET [/api/v1/accounts/lookup](https://docs.joinmastodon.org/methods/accounts/#lookup)

#### announcements

- [ ] GET [/api/v1/announcements](https://docs.joinmastodon.org/methods/announcements/#get)
- [ ] POST [/api/v1/announcements/:id/dismiss](https://docs.joinmastodon.org/methods/announcements/#dismiss)
- [ ] PUT [/api/v1/announcements/:id/reactions/:name](https://docs.joinmastodon.org/methods/announcements/#put-reactions)
- [ ] DELETE [/api/v1/announcements/:id/reactions/:name](https://docs.joinmastodon.org/methods/announcements/#delete-reactions)

#### blocks

- [ ] GET [/api/v1/blocks](https://docs.joinmastodon.org/methods/blocks/#get)

#### bookmarks

- [ ] GET [/api/v1/bookmarks](https://docs.joinmastodon.org/methods/bookmarks/#get)

#### conversations

- [ ] GET [/api/v1/conversations](https://docs.joinmastodon.org/methods/converstions/#get)
- [ ] DELETE [/api/v1/conversations/:id](https://docs.joinmastodon.org/methods/converstions/#delete)
- [ ] POST [/api/v1/conversations/:id/read](https://docs.joinmastodon.org/methods/converstions/#read)

#### custom_emojis

- [ ] GET [/api/v1/custom_emojis](https://docs.joinmastodon.org/methods/custom_emojis/#get)

#### directory

- [ ] GET [/api/v1/directory](https://docs.joinmastodon.org/methods/directory/#get)

#### domain_blocks

- [ ] GET [/api/v1/domain_blocks](https://docs.joinmastodon.org/methods/domain_blocks/#get)
- [ ] POST [/api/v1/domain_blocks](https://docs.joinmastodon.org/methods/domain_blocks/#block)
- [ ] POST [/api/v1/domain_blocks](https://docs.joinmastodon.org/methods/domain_blocks/#unblock)

#### emails

- [ ] POST [/api/v1/emails/confirmations](https://docs.joinmastodon.org/methods/emails/#confirmation)

#### endorsements

- [ ] GET [/api/v1/endorsements](https://docs.joinmastodon.org/methods/endorsements/#get)

#### favourites

- [ ] GET [/api/v1/favourites](https://docs.joinmastodon.org/methods/favourites/#get)

#### featured_tags

- [ ] GET [/api/v1/featured_tags](https://docs.joinmastodon.org/methods/featured_tags/#get)
- [ ] POST [/api/v1/featured_tags](https://docs.joinmastodon.org/methods/featured_tags/#feature)
- [ ] GET [/api/v1/featured_tags/:id](https://docs.joinmastodon.org/methods/featured_tags/#unfeature)
- [ ] GET [/api/v1/featured_tags/suggestions](https://docs.joinmastodon.org/methods/featured_tags/#suggestions)

#### filters

- [ ] GET [/api/v2/filters](https://docs.joinmastodon.org/methods/filters/#get)
- [ ] GET [/api/v2/filters/:id](https://docs.joinmastodon.org/methods/filters/#get-one)
- [ ] POST [/api/v2/filters](https://docs.joinmastodon.org/methods/filters/#create)
- [ ] PUT [/api/v2/filters/:id](https://docs.joinmastodon.org/methods/filters/#update)
- [ ] DELETE [/api/v2/filters/:id](https://docs.joinmastodon.org/methods/filters/#delete)
- [ ] GET [/api/v2/filters/:filter_id/keywords](https://docs.joinmastodon.org/methods/filters/#keywords-get)
- [ ] POST [/api/v2/filters/:filter_id/keywords](https://docs.joinmastodon.org/methods/filters/#keywords-create)
- [ ] GET [/api/v2/filters/keywords/:id](https://docs.joinmastodon.org/methods/filters/#keywords-get-one)
- [ ] PUT [/api/v2/filters/keywords/:id](https://docs.joinmastodon.org/methods/filters/#keywords-update)
- [ ] DELETE [/api/v2/filters/keywords/:id](https://docs.joinmastodon.org/methods/filters/#keywords-delete)
- [ ] GET [/api/v2/filters/:filter_id/notes](https://docs.joinmastodon.org/methods/filters/#statuses-get)
- [ ] POST [/api/v2/filters/:filter_id/notes](https://docs.joinmastodon.org/methods/filters/#statuses-add)
- [ ] GET [/api/v2/filters/notes/:id](https://docs.joinmastodon.org/methods/filters/#statuses-get-one)
- [ ] DELETE [/api/v2/filters/notes/:id](https://docs.joinmastodon.org/methods/filters/#statuses-remove)

#### follow_requests

- [ ] GET [/api/v1/follow_requests](https://docs.joinmastodon.org/methods/follow_requests/#get)
- [ ] POST [/api/v1/follow_requests/:account_id/authorize](https://docs.joinmastodon.org/methods/follow_requests/#accept)
- [ ] POST [/api/v1/follow_requests/:account_id/reject](https://docs.joinmastodon.org/methods/follow_requests/#reject)

#### followed_tags

- [ ] GET [/api/v1/followed_tags](https://docs.joinmastodon.org/methods/followed_tags/#get)

#### grouped_notifications

- [ ] GET [/api/v2/notifications](https://docs.joinmastodon.org/methods/grouped_notifications/#get-grouped)
- [ ] GET [/api/v2/notifications/:group_key](https://docs.joinmastodon.org/methods/grouped_notifications/#get-notification-group)
- [ ] POST [/api/v2/notifications/:group_key/dismiss](https://docs.joinmastodon.org/methods/grouped_notifications/#dismiss-group)
- [ ] GET [/api/v2/notifications/:group_key/accounts](https://docs.joinmastodon.org/methods/grouped_notifications/#get-group-accounts)
- [ ] GET [/api/v2/notifications/unread_count](https://docs.joinmastodon.org/methods/grouped_notifications/#unread-group-count)

#### instance

- [ ] GET [/api/v2/instance](https://docs.joinmastodon.org/methods/instance/#v2)
- [ ] GET [/api/v2/instance/peers](https://docs.joinmastodon.org/methods/instance/#peers)
- [ ] GET [/api/v2/instance/activity](https://docs.joinmastodon.org/methods/instance/#activity)
- [ ] GET [/api/v2/instance/rules](https://docs.joinmastodon.org/methods/instance/#rules)
- [ ] GET [/api/v2/instance/domain_blocks](https://docs.joinmastodon.org/methods/instance/#domain_blocks)
- [ ] GET [/api/v2/instance/extended_description](https://docs.joinmastodon.org/methods/instance/#extended_description)
- [ ] GET [/api/v2/instance/privacy_policy](https://docs.joinmastodon.org/methods/instance/#privacy_policy)
- [ ] GET [/api/v2/instance/terms_of_service](https://docs.joinmastodon.org/methods/instance/#terms_of_service)
- [ ] GET [/api/v2/instance/terms_of_service/:date](https://docs.joinmastodon.org/methods/instance/#terms_of_service_date)
- [ ] GET [/api/v2/instance/translation_languages](https://docs.joinmastodon.org/methods/instance/#translation_languages)

#### lists

- [ ] GET [/api/v1/lists](https://docs.joinmastodon.org/methods/lists/#get)
- [ ] GET [/api/v1/lists/:id](https://docs.joinmastodon.org/methods/lists/#get-one)
- [ ] POST [/api/v1/lists](https://docs.joinmastodon.org/methods/lists/#create)
- [ ] PUT [/api/v1/lists/:id](https://docs.joinmastodon.org/methods/lists/#update)
- [ ] DELETE [/api/v1/lists/:id](https://docs.joinmastodon.org/methods/lists/#delete)
- [ ] GET [/api/v1/lists/:id/accounts](https://docs.joinmastodon.org/methods/lists/#accounts)
- [ ] POST [/api/v1/lists/:id/accounts](https://docs.joinmastodon.org/methods/lists/#accounts-add)
- [ ] DELETE [/api/v1/lists/:id/accounts](https://docs.joinmastodon.org/methods/lists/#accounts-remove)

### Features

- [ ] Lightweight web interface
- [ ] API compatible with other ActivityPub instances
- [ ] JWT
- [ ] Groups
- [ ] Formatting: big/medium/small title, bold, italic, strikethrough, link, code, code block
- [ ] Links preview
- [ ] Timelines: Home / Local / Global / Custom
- [ ] Global search
- [ ] Bookmarks
- [ ] Profile links verification
- [ ] Links preview
- [ ] Import/Export posts
- [x] Sync user settings on the server
- [ ] Restricted direct messages
- [ ] Direct messages tab

### Server configuration

* Disk space limit per user
* Limit on posts (count/time)

### User settings

#### Profile

* Avatar
* Banner
* Name
* Bio
* Location
* Birthday
* Links
* Follow requests approval
* Toggle reacts under own posts
* Toggle view of reacts under posts
* Profile migration
* Delete account

===== Disk Usage: 100 MB (20%) =====

#### Security

* Change password
* Token
* Enable/Disable email login notifications
* Sessions

| IP              | Datetime            | Action |
| ----------------|---------------------|--------|
| 127.0.0.1       | 2025-01-01 00:00:00 | revoke |
| 127.127.127.127 | 2025-02-02 00:00:00 | revoke |

#### Filters

* Placeholder with rules

```
filter keyword #tag user@example.com example.com
```

* Show replies of all followed users
* Show replies of this followed users

## Contributing

### Patches via Email

You can create a patch with this command `git format-patch -M origin/main` and send it to this [email address](mailto:miraikumiko@disroot.org). Check out this [guide](https://git-send-email.io).

### Your repository

You fork this repository and make your changes in the feature branch, then I pull it.
